﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.Windows.Forms;
using GDIDB;

namespace TestFlicker
{
    public partial class Form1 : Form
    {
        private DBGraphics memGraphics;
        private DrawObject drawObj;

        public Form1()
        {
            memGraphics = new DBGraphics();
            drawObj = new DrawObject();

            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            memGraphics.CreateDoubleBuffer(this.CreateGraphics(), this.ClientRectangle.Width, this.ClientRectangle.Height);
        }

        protected override void OnPaintBackground(PaintEventArgs e)
        {
            //base.OnPaintBackground(e);
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            memGraphics.CreateDoubleBuffer(this.CreateGraphics(), this.ClientRectangle.Width, this.ClientRectangle.Height);
            Invalidate();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (memGraphics.CanDoubleBuffer())
            {
                System.Diagnostics.Debug.WriteLine("Form - Paint - DoubleBuffer");
                memGraphics.g.FillRectangle(new SolidBrush(SystemColors.Window),
                    e.ClipRectangle.X, e.ClipRectangle.Y, e.ClipRectangle.Width, e.ClipRectangle.Height);
                drawObj.Draw(memGraphics.g);
                memGraphics.Render(e.Graphics);
            }
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left && drawObj.HitTest(new Point(e.X, e.Y)))
            {
                this.Capture = true;
                drawObj.BeginDrag(new Point(e.X, e.Y));
            }
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            if (drawObj.IsDragging())
            {
                drawObj.Drag(new Point(e.X, e.Y), this);
            }
        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            if (drawObj.IsDragging())
            {
                drawObj.EndDrag();
            }
        }                
    }
}
